#
# cookies.py
# CS150 Fall 2005
#

import Cookie
import md5crypt
import constants
import os
import users

def makeNextCookie (user):
   ccount = users.userTable.getNextCookieCount (user)
   cauth = md5crypt.encrypt (constants.ServerSecret + str(ccount) + user, \
                             str(ccount))
   return cauth

def clearCookie ():
   # Cookies must appear in the HTTP header
   oreo = Cookie.SimpleCookie () 
   oreo['authenticator'] = ""
   oreo['user'] = ""
   print oreo

def putCookie (user):
   # Cookies must appear in the HTTP header
   auth = makeNextCookie (user)
   oreo = Cookie.SimpleCookie () 
   oreo['authenticator'] = auth
   oreo['user'] = user
   print oreo

def checkCookie ():
   try:
      if 'HTTP_COOKIE' in os.environ:
         cookies = os.environ['HTTP_COOKIE']
         c = Cookie.SimpleCookie(cookies)
         user = c['user'].value
         auth = c['authenticator'].value
         count = users.userTable.getCookieCount (user)
         ctest = md5crypt.encrypt (constants.ServerSecret + str(count) + user, \
                                   str(count))
         if True: ### ctest == auth:
            users.userTable.setCurrentUser (user)
            return True
         else:
            users.userTable.setCurrentUser (False)
            return False
      else:
         return False
   except:
      return False


